import  sys
import codecs

if len(sys.argv)<2:
    print "python programma_estraiRegole.py nomefile.out"
    exit()

def Ordina(dict):
    return sorted(dict.items(), key=lambda x: x[1], reverse=True)

def main(file1):
    fileRegole=codecs.open(file1, "r", "utf8")
    Frasi={}
    Frasi_freq={}
    REGOLE={}
    REGOLE_freq={}
    for l in fileRegole:
        if l =="":
            break
        lS=l.strip().split("\t")
        frase=tuple(lS[1:])
        if not(frase in Frasi_freq):
            Frasi_freq[frase]=0.0
        Frasi_freq[frase]+=1.0
        stringa=""
        for (x,y) in enumerate(frase):
            if not(x%2==1):
                if not(y in REGOLE):
                    REGOLE_freq[y]=0.0
                    REGOLE[y]=0.0
                REGOLE[y]+=1.0
                stringa+=y+" "
            else:
                REGOLE_freq[frase[x-1]]+=float(y)
        stringa=stringa.strip()
        if not(stringa in Frasi):
            Frasi[stringa]=0.0
        Frasi[stringa]+=1.0

    
    REGOLE_ord=Ordina(REGOLE)
    REGOLE_freq_ord=Ordina(REGOLE_freq)
    Frasi_ord=Ordina(Frasi)
    Frasi_freq_ord=Ordina(Frasi_freq)


    print "RISULTATI:"
    print
    print "1) Frequenza di applicazione delle REGOLE:"
    for elem in  REGOLE_freq_ord:
        stringa=elem[0]+"\t"+str(elem[1])
        print stringa
    print
    print "2) numero di frasi alle quali sono state applicate le varie REGOLE:"
    for elem in  REGOLE_ord:
        stringa=elem[0]+"\t"+str(elem[1])
        print stringa
    print
    print "3) Frequenza di combinazione di regole (senza frequenza) nelle frasi:"
    for elem in  Frasi_ord:
        stringa=elem[0]+"\t"+str(elem[1])
        print stringa
    print
    print "4) Frequenza di combinazione di regole (compresa la frequenza) nelle frasi:"
    for elem in  Frasi_freq_ord:
        stringa1=""
        for x in elem[0]:
            stringa1+=str(x)+" "
        stringa=stringa1.strip() +"\t"+str(elem[1])
        print stringa
        
main(sys.argv[1])
