import  sys
import codecs

if len(sys.argv)<3:
    print "python programma_estraiRegole.py nomefile.txt nomefile.ann"
    exit()

def Ordina(dict):
    return sorted(dict.items(), key=lambda x: x[0], reverse=False)



def main(file1, file2):
    fileInput1=codecs.open(file1, "r", "utf8")
    fileRegole=codecs.open(file2, "r", "utf8")
    testo=fileInput1.read()
    conta_Caratteri=0
    conta_Frase=1
    listaRegole=[]
    for l in fileRegole:
        if l[0]=="T":
            lS=l.split("\t")
            lSS=lS[1].split(" ")
            rangeRegolaFine=lSS[-1]
            rangeRegolaInizio=lSS[-2]
            listaRegole.append((lSS[0], rangeRegolaInizio, rangeRegolaFine))
    Dizionario={}
    for regola in listaRegole:
        inizio=int(regola[1])
        fine=int(regola[2])
        conta_Frase=1
        for c in testo[0: inizio]:
            if c=="\n":
                conta_Frase+=1
        if conta_Frase in Dizionario:
            if not (regola[0] in Dizionario[conta_Frase]):
                Dizionario[conta_Frase][regola[0]]=0.0
            Dizionario[conta_Frase][regola[0]]+=1.0
        else:
            Dizionario[conta_Frase]={}
            Dizionario[conta_Frase][regola[0]]=1.0
    
    for frase in  Dizionario:
        stringa=str(frase)+"\t"
        regoleOrdinate=Ordina(Dizionario[frase])
        
        for regola in regoleOrdinate:
            
            stringa+=regola[0]+"\t"+str(regola[1])+"\t"
        print stringa

        
main(sys.argv[1], sys.argv[2])
